//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ImageShrink0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void shrink(Graphics::TBitmap *bmp, float sx, float sy)
{ int x, y, px, py, bkx, bky, h, w;
  int mWidth, mHeight;
  unsigned long index;
  float value;
  BYTE *ptr, *pImg;
  Graphics::TBitmap *mBmp = new Graphics::TBitmap();

  mBmp->Assign(bmp);  // ƥ
  mBmp->PixelFormat = pf24bit;
  
  w = mBmp->Width * sx;  // pYϤؤo
  h = mBmp->Height* sy;
  bmp->Width  = w;
  bmp->Height = h;
  bmp->PixelFormat = pf24bit;

  mWidth  = mBmp->Width;
  mHeight = mBmp->Height;
  
  sx = 1.0/sx;  sy = 1.0/sy;
  unsigned long idxImg=0L;
  int gray[3];
  for (py=0; py<h; py++)
     { pImg = (Byte *) bmp->ScanLine[py];
       for (px=0; px<w; px++)
  	  { x = px*sx;
            y = py*sy;
            idxImg = y*mWidth+x;

            gray[0]=gray[1]=gray[2]=0;
            for (bky=0; bky<sy; bky++)  // o϶C⪺
               { ptr = (Byte *) mBmp->ScanLine[y+bky];
                 for (bkx=0; bkx<sx; bkx++)
                    { gray[0] += ptr[3*(x+bkx)  ];
                      gray[1] += ptr[3*(x+bkx)+1];
                      gray[2] += ptr[3*(x+bkx)+2];
                    }
               }
            for (int k=0; k<3; k++) gray[k] /= (bkx*bky);
            pImg[3*px  ] = gray[0];
            pImg[3*px+1] = gray[1];
            pImg[3*px+2] = gray[2];
  	  }
     }
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{ float sx=0.25, sy=0.25;
  shrink(Image1->Picture->Bitmap, sx, sy);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Jpeg2BitmapClick(TObject *Sender)
{
  Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = Image1->Picture->Width;
  bmp->Height = Image1->Picture->Height;
  bmp->Canvas->Draw(0, 0, Image1->Picture->Graphic);
  Image1->Picture->Assign(bmp);

  delete bmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSaveClick(TObject *Sender)
{
  Image1->Picture->SaveToFile("shrink.bmp");        
}
//---------------------------------------------------------------------------

